#!/usr/bin/env node


//请千万注意，本文将只能用LF！！！

const dayjs = require('dayjs')
const colors = require('colors')
const fs = require('fs')
const InnerKenTimeStampFormat = 'YYYYMMDDHHmmss'
const prompts = require('prompts')
const {deviceEcho} = require('./modules/firebase')
const GlobalDeviceId = 'notset'

const {program} = require('commander')
const cli = require('./modules/cli-utils')
const {hillo} = require('hillo')
const version = require('./package.json').version

program.version(version)

hillo.initial('http://innerken.com/iplogger/')

console.log(
    '*******************************************************\n' +
    'Aaden CLI'.bgCyan + ' Version:' + version.bgRed + '\n' +
    'Made with ' + '❤'.red + ' and InnerKen \n' +
    '*******************************************************'
)
program
    .option('-d, --debug', 'use Debug Out put')
program.command('update [channel]').action(update)
program
    .command('install <deviceId>')
    .action(install)
program.command('remove-all-data').action(removeAllData)
program.command('mount-tse').action(remountTSE)
program.command('upgrade').action(upgrade) // auto execute.
program.command('auto-upgrade').action(autoUpgrade) // auto execute.
program.command('load-new-version').action(loadNewVersion) // auto execute.
program.command('local-version').action(() => {
    console.log('storage:' + getStorageBackendFileVersion())
})
program.command('backup [noUpload]').action(backup)
program.command('ngrok').action(startNgrokService)
program.command('update-ngrok-config <deviceId>').action(updateNgrokConfig)
program.command('run <filePath>').action(run)
program.command('patch').action(patch)
program.command('check-tse').action(checkTse)
program.command('setup-tse').action(enableTSE)
program.command('check-version').action(getBackendVersionOffline)
program.command('add-dish').action(addDish)
program.command('full-update').action(fullUpdate)
program.command('return-terminal').action(returnTerminal)
program.command('db').action(enterDatabase)
program.command('printer-test').action(testPrinter)
program.command('log').action(log)
program.command('fix-cronjob').action(fixCronJob)
program.command('convert-database').action(convertDataBaseCharset)

program.command('enable-resource-track').action(enableResourceTrack)
program.command('start-resource-track').action(startResourceTrack)
program.command('auto-send-mail').action(editIni)
program.command('auto-send-summary').action(autoSendSummaryLastMonth)
program.command('set-do-not-send-zbon-when-print-true').action(editConfigIni(setConfig('Email', 'DoNotSendZbonWhenPrint', true)))
program.command('set-do-not-send-zbon-when-print-false').action(editConfigIni(setConfig('Email', 'DoNotSendZbonWhenPrint', false)))
program.command('set-auto-send-3in1-today-true').action(editConfigIni(setConfig('Email', 'AutoSend3in1Today', true)))
program.command('set-auto-send-3in1-today-false').action(editConfigIni(setConfig('Email', 'AutoSend3in1Today', false)))
program.command('set-print-change-table-bon-true').action(editConfigIni(setConfig('Bon', 'PrintChangeTableBon', true)))
program.command('set-print-change-table-bon-false').action(editConfigIni(setConfig('Bon', 'PrintChangeTableBon', false)))
program.command('send-single-bon-without-zip-true').action(editConfigIni(setConfig('Email', 'SendSingleBonWithoutZip', true)))
program.command('send-single-bon-without-zip-false').action(editConfigIni(setConfig('Email', 'SendSingleBonWithoutZip', false)))
program.command('auto-write-gdpdu').action(autoWriteGdpdu)
program.command('export-tse').action(exportTse)
program.command('fix-ngrok').action(fixNgrok)
program.command('do-log').action(doLog)

if (program.debug) {
    debugInfo()
    console.log(process.argv)
}
basicInfo()

if (process.argv[2] === undefined) {
    selectOption()
} else {
    program.parse(process.argv)
}

function basicInfo() {
    console.log('本设备DeviceId:' + getMyDeviceId().toString().bgYellow)
    console.log('本设备当前后台版本:' + getBackendVersionOffline().bgYellow)
    console.log('开始执行命令:' + process.argv.join(' ').cyan)
    console.log('...')
}

async function selectOption() {
    const select = await prompts({
        type: 'autocomplete',
        name: 'option',
        message: 'Select what you want to do next? ' +
            '请选择下一步要进行的操作',
        choices: [
            {title: 'Upgrade Aaden-cli 手动更新Aaden-cli到最新版本', description: '', value: 'upgrade'},
            {
                title: 'Backup all backend data 备份后端数据库数据',
                description: '操作数据库数据前请先备份',
                value: 'backup'
            },
            {title: 'Full update 全更新', description: '更新前请先备份', value: 'full-update'},
            {title: 'Check Tse 检查Tse设备', description: '', value: 'check-tse'},
            {title: 'Start Ngrok 打开Ngrok服务', description: '', value: 'ngrok'},
            {title: 'Install Aaden Kasse 安装最新版Aaden Kasse', value: `install ${GlobalDeviceId}`},
            {
                title: 'Add Dishes 执行上菜脚本app.py',
                description: '-p ImgPath -i DishCSVPath -a AttrPath',
                value: 'add-dish'
            },
            {title: 'Check version 检查后端版本号', description: '', value: 'check-version'},
            {title: 'Patch 打补丁', description: '请勿手动执行', value: 'patch'},
            {title: 'Remove all data 删除所有数据', description: '谨慎操作'.red, value: 'remove-all-data'},
            {title: 'Setup Tse 安装Tse', description: '谨慎操作'.red + ' 每个设备只能安装一次TSE', value: 'setup-tse'},
            {
                title: 'Mount Tse 永久挂载Tse设备',
                description: '谨慎操作'.red + ' ' +
                    '进行此操作会导致TSE重新自检,使用前请先检查是否已经正确插入Tse设备（Tse设备是否正常亮灯）',
                value: 'mount-tse'
            },
            {
                title: 'Update Ngrok 更新Ngrok配置',
                description: '输入本设备的DeviceId，更新Ngrok配置',
                value: `update-ngrok-config ${GlobalDeviceId}`
            },
            {title: 'Exit 退出', description: 'return to terminal', value: 'return-terminal'}
        ],
        initial: 1
    })

    if (select.option) {
        console.log(select.option)
        process.argv = [...process.argv, ...select.option.split(' ')]
        program.parse(process.argv)
    }
}

function log() {
    cli.executeInShell(['tail -f /var/www/html/Resource/failLog.log'])
}

function enterDatabase() {
    const command = [
        `mysql -uaaden -pInnerken322. -Daaden`
    ]
    cli.executeInShell(command, program.debug)
}

function fixNgrok() {
    run('AadenDeploy/Utils/enableNgrok.sh')
}

function testPrinter() {
    const command = [
        `wget localhost/PHP/Complex.php?op=testAllPrinter`
    ]
    cli.executeInShell(command, program.debug)
}

function getDatabase() {
    const command = [
        `mysqldump -uaaden -pInnerken322. --databases aaden --tables Attribute AttributeGroup BonTemplate Category_AttributeGroup DishWithName Dish_AttributeGroup Dishes DishesString DishesCategory DishesCategoryString> transfer.sql`,
        'sudo cp transfer.sql /var/www/html'
    ]
    cli.executeInShell(command, program.debug)
}

function getNewDatabase() {
    const command = [
        `mysqldump -uaaden -pInnerken322. --databases aaden --tables Attribute AttributeGroup BonTemplate Category_AttributeGroup DishWithName Dish_AttributeGroup Dishes DishesString DishesCategory DishesCategoryString DishesCategoryType DishesCategoryTypeString ConsumeType_Dishes_Free ConsumeType_Dishes_Show> transfer.sql`,
        'sudo cp transfer.sql /var/www/html'
    ]
    cli.executeInShell(command, program.debug)
}

function debugInfo() {
    console.log(program.opts())
    console.log('')
}

function checkTse() {
    cli.executeInShell(['journalctl -f -u aaden-tse.service'], program.debug)
}

function remountTSE() {
    const files = ['AadenDeploy/mountTSE.sh']
    runMultiple(files)
}

function enableTSE() {
    const files = ['AadenDeploy/mountTSE.sh', 'AadenDeploy/Utils/tseReady.sh']
    runMultiple(files)
}

function fixCronJob() {
    const files = ['AadenDeploy/Utils/fixCronJob.sh']
    runMultiple(files)
}

function exportTse() {
    const files = ['AadenDeploy/Utils/exportTse.sh']
    runMultiple(files)
}


async function patch() {
    const configRoot = '/etc/aaden/config'
    const rootPath = __dirname + '/patch'
    const patchRecordFilePath = configRoot + '/patchLog.json'
    const pathList = fs.readdirSync(rootPath)

    let readyList = []
    try {
        readyList = JSON.parse(fs.readFileSync(patchRecordFilePath))
    } catch (e) {
        console.error(e)
        console.log('Create Patch Log File in :-->>' + patchRecordFilePath)
        fs.openSync(patchRecordFilePath, 'w+')
    }
    const runList = pathList.map(p => 'patch/' + p).filter(p => {
        return !readyList.includes(p)
    })

    if (runList.length > 0) {
        runMultiple(runList)
        readyList = readyList.concat(runList)
        fs.writeFileSync(patchRecordFilePath, JSON.stringify(readyList))
    }

}

async function runMultiple(files) {
    const command = files.reduce((arr, f) => {
        arr.push(...getPrivilegeCMD(f))
        arr.push('./' + f)
        return arr
    }, [])
    cli.executeInShell(command, program.debug)
}

async function run(filePath) {
    const command = [
        ...getPrivilegeCMD(filePath),
        './' + filePath
    ]
    cli.executeInShell(command, program.debug)
}

function fullUpdate() {
    const command = [
        'aaden-cli backup',
        'sudo npm install aaden-cli -g',
        'aaden-cli upgrade',
        'aaden-cli update',
        'aaden-cli fix-cronjob',
        'aaden-cli auto-write-gdpdu',
    ]
    cli.executeInShell(command, program.debug)
}

async function updateNgrokConfig(deviceId) {
    console.log(deviceId)
    if (!deviceId || deviceId === 'notset') {
        const getDeviceId = await prompts({
            type: 'number',
            name: 'id',
            message: '请输入要配置ngrok的设备Id:'
        })
        deviceId = getDeviceId.id
    }

    console.log('Start to config Ngrok service')
    console.log('开始配置' + deviceId + '设备的Ngrok服务')

    const command = [
        'cd /etc',
        'sudo mkdir -p aaden',
        'cd aaden',
        'sudo touch ngrok-config.yml',
        'sudo chmod 777 ngrok-config.yml',
        `echo "
server_addr: ngrok.aaden.io:4443
trust_host_root_certs: true
tunnels:
    web:
       proto:
            https: 80
       subdomain: ik${String(deviceId).padStart(4, '0')}
    http:
       proto:
            http: 80
       subdomain: ik${String(deviceId).padStart(4, '0')}
    ssh:
        proto:
            tcp: 22
        remote_port: ${parseInt(deviceId) + 10000}" > ngrok-config.yml`
    ]
    cli.executeInShell(command, program.debug)
}

async function startNgrokService() {
    const command = [
        ...getPrivilegeCMD('AadenDeploy/ngrok/ngrok'),
        'cd AadenDeploy/ngrok',
        './ngrok -config=/etc/aaden/ngrok-config.yml start-all --log=/etc/aaden/ngrok.log'
    ]
    cli.executeInShell(command, program.debug)
}

async function backup(noUpload = false) {
    const timeStamp = dayjs().format(InnerKenTimeStampFormat)
    const backupHome = 'appendBackup'
    const command = [
        'cd',
        'sudo mkdir -p backups',
        'sudo chmod 777 backups',
        'sudo mkdir -p backups/' + timeStamp,
        'sudo chmod 777 backups/' + timeStamp,
        'cd backups/' + timeStamp,
        `mysqldump aaden -uaaden -pInnerken322. -c> ${timeStamp}@cli.sql`,
        'cd',
        'sudo mkdir -p ' + backupHome,
        'sudo chmod 777 ' + backupHome,
        'cd ' + backupHome,
        'sudo rsync -av --delete /var/www/html/ .'
    ]

    cli.executeInShell(command, program.debug)
    // if (!noUpload) {
    //     setTimeout(() => {
    //         const homedir = require('os').homedir()
    //         const fileName = [homedir, 'backups', timeStamp, `${timeStamp}@cli.sql`].join('/')
    //         uploadFile(fileName)
    //     }, 8000)
    // }


}

async function updateCheck(channel = '') {
    const result = {
        version: true,
        file: true
    }
    console.log('正在检查是否有必要进行后台更新..'.bgYellow)
    const localVersion = getBackendVersionOffline()
    console.log('本机版本:' + localVersion.bgRed)
    const remoteVersion = (await hillo.get('https://aaden-backend.s3.eu-central-1.amazonaws.com/raw/package.json')).version
    console.log('服务器最新版本:' + remoteVersion.bgMagenta)
    const localStorageVersion = getStorageBackendFileVersion()
    console.log('本地最新文件版本' + localStorageVersion)
    if (remoteVersion === localVersion) {
        console.log('你已经在使用最新版本，无需更新'.red)
        result.file = true
    } else {
        result.version = false
        if (remoteVersion === localStorageVersion) {
            console.log('文件已经就绪，可以直接更新:' + remoteVersion + '------>' + localVersion.bgRed)

        } else {
            console.log('缓存文件比较老，需要进行更新:' + remoteVersion + '------>' + localVersion.bgRed)
            result.file = false
        }

    }
    return result
}

async function convertDataBaseCharset() {
    try {
        const result = await updateCheck()
        if (result.version) {
            return
        }
        if (!result.file) {
            const command = [
                ...getPrivilegeCMD('AadenDeploy/Utils/updateDataBaseCharSet.sh'),
                'cd AadenDeploy/Utils',
                `./updateDataBaseCharSet.sh`
            ]
            cli.executeInShell(command, program.debug)
        } else {
            console.log('已经转换完成')
        }
    } catch (e) {
        console.error(e)
    }

}


async function loadNewVersion() {
    try {
        const result = await updateCheck()
        if (result.version) {
            return
        }
        if (!result.file) {
            const command = [
                ...getPrivilegeCMD('AadenDeploy/files/getFile.sh'),
                'cd AadenDeploy/files',
                `./getFile.sh`
            ]
            cli.executeInShell(command, program.debug)
        } else {
            console.log('后端文件已经是最新')
        }
    } catch (e) {
        console.error(e)
    }

}

async function update(channel = '') {
    if (channel !== '') {
        channel += '/'
    }
    try {
        const result = await updateCheck(channel)
        const command = []
        if (result.version) {
            return
        }
        if (!result.file) {
            command.push('aaden-cli load-new-version')
        }
        command.push(...[
            ...getPrivilegeCMD('AadenDeploy/update.sh'),
            'cd AadenDeploy',
            `./update.sh ${channel}`
        ])
        cli.executeInShell(command, program.debug)
    } catch (e) {
        console.error(e)
    }

}

async function install(deviceId) {
    const channel = 'stable'
    const installApp = true
    if (!deviceId || deviceId === 'notset') {
        const getId = await prompts({
                type: 'number',
                name: 'deviceId',
                message: '请输入需要安装的设备号：'
            }
        )
        deviceId = getId.deviceId
    }
    if (deviceId) {
        const command = [
            ...getPrivilegeCMD('AadenDeploy/aadensetup.sh'),
            'cd AadenDeploy',
            `./aadensetup.sh ${deviceId} ${channel}` + (installApp ? ' b' : '')
        ]
        cli.executeInShell(command, program.debug)
    } else {
        console.log('Device Id is invalid.')
    }
}

function getMyDeviceId() {
    const loadIniFile = require('read-ini-file')
    try {
        return loadIniFile.sync('/var/www/html/Resource/config/config.ini').Device.DeviceId
    } catch (e) {
        return -1
    }

}

async function autoUpgrade() {
    upgrade()
}

function upgrade() {
    const command = [
        ...getPrivilegeCMD('AadenDeploy/upgrade.sh'),
        'cd AadenDeploy',
        `./upgrade.sh`
    ]
    cli.executeInShell(command, program.debug)
}

function getStorageBackendFileVersion() {
    const jsonFilePath = '/etc/aaden/updateFiles/backendFiles/package.json'
    let frontVersion
    try {
        frontVersion = require(jsonFilePath).version
    } catch (e) {
        console.log(e)
        frontVersion = '0.0.0'
    }
    return frontVersion

}

function getBackendVersionOffline() {
    const jsonFilePath = '/var/www/html/package.json'
    let frontVersion
    try {
        frontVersion = require(jsonFilePath).version
    } catch (e) {
        frontVersion = '0.0.0'
    }
    return frontVersion

}

async function addDish() {
    console.log('添加菜品需要以下菜品信息：')
    const getDishPath = await prompts({
            type: 'text',
            name: 'dishPath',
            message: '请输入菜品的csv路径：'
        }
    )
    const dishPath = getDishPath.dishPath
    const getImgPath = await prompts({
            type: 'text',
            name: 'imgPath',
            message: '请输入菜品的图片路径：'
        }
    )
    const imgPath = getImgPath.imgPath
    const judge = await prompts({
        type: 'toggle',
        name: 'add',
        message: '是否有需要添加的菜品属性：',
        initial: false,
        active: 'yes',
        inactive: 'no'
    })
    let attrPath = undefined
    if (judge.add) {
        const getAttrPath = await prompts({
                type: 'text',
                name: 'attrPath',
                message: '请输入菜品的属性路径：'
            }
        )
        attrPath = getAttrPath.attrPath
    }
    console.log('Adding dishes now...')
    if (dishPath !== undefined && imgPath !== undefined) {
        if (attrPath !== undefined) {
            const command = [
                ...getPrivilegeCMD('AadenDeploy/add_dish'),
                'cd AadenDeploy/dish_app',
                `sudo python3 app.py -i ${dishPath} -p ${imgPath} -a ${attrPath}`
            ]
            cli.executeInShell(command, program.debug)
            console.log('Add Dishes with Attribute success!')
        } else {
            const command = [
                ...getPrivilegeCMD('AadenDeploy/add_dish'),
                'cd AadenDeploy/dish_app',
                `sudo python3 app.py -i ${dishPath} -p ${imgPath}`
            ]
            cli.executeInShell(command, program.debug)
            console.log('Add Dishes without Attribute success!')
        }
    } else {
        console.log('DishPath or ImgPath is required but not valid')
    }
}

function findMe() {
    return __dirname
}

function goIntoRootDir() {
    return 'cd ' + findMe() + '&& cd ..'
}

async function removeAllData() {
    const start = await prompts({
        type: 'toggle',
        name: 'ok',
        message: `Are your sure you want to remove all data of this customer?
    你确定你要删除这个用户的所有数据吗?
    このユーザーのすべてのデータを削除してもよろしいですか？
    Möchten Sie wirklich alle Daten dieses Benutzers löschen?
    이 사용자의 모든 데이터를 삭제 하시겠습니까?
    Tu Visne vero hanc user notitia omnes delere?
    Êtes-vous sûr de vouloir supprimer toutes les données de cet utilisateur?
    确定？Are you Sure?
    `,
        initial: false,
        active: 'yes(我确定)',
        inactive: 'no(不，我后悔了)'
    })
    if (!start.ok) {
        return
    }
    console.log('你的行为将会被记录在公司服务器上，请谨慎操作。'.bgRed)

    const response = await prompts({
        type: 'password',
        name: 'value',
        message: '请输入易能科技人员认证密码:'
    })
    const correctPassword = ['yjn.2081214', '728339jhq']
    if (!correctPassword.includes(response.value)) {
        console.log('>密码错误，未认证用户。'.bgYellow)
        return
    }
    console.log('欢迎进入新版AadenCli系统，您的身份已经获得认证'.bgYellow)
    console.log('>现在开始清除用户数据...')
    const command = [
        'aaden-cli backup',
        goIntoRootDir(),
        'echo "请输入数据库密码(和开机密码，sudo密码相同)"',
        'mysql -u aaden -p < AadenDeploy/purge.sql'
    ]
    cli.executeInShell(command, program.debug)
}


async function doLog() {
    const res = cli.executeInShell(['snap info aaden-vue-app'], program.debug, true)
    const log = res.output
    const list = log.split('\n')
    const frontendVersion = list[list.length - 2].replace(/\s+/g, ' ')
        .split(' ')[1]
    console.log(frontendVersion)
    await deviceEcho(frontendVersion, version)
    console.log('finish')

    process.exit(0)
}

async function enableResourceTrack() {
    cli.executeInShell([
        'cd /home/aaden',
        'mkdir aaden-resource-track',
        'cd aaden-resource-track',
        'axel -n 6 http://ik0001.ngrok.aaden.io/resource-track-0.0.1-jar-with-dependencies.jar',
        'wget http://ik0001.ngrok.aaden.io/serve-resource-track.sh',
        'wget http://ik0001.ngrok.aaden.io/start-resource-track.sh',
        'sudo chmod 777 serve-resource-track.sh',
        'wget http://ik0001.ngrok.aaden.io/aaden-resource-track.sql',
        'aaden-cli start-resource-track',
    ], program.debug)
}

async function startResourceTrack() {
    cli.executeInShell([
        'echo "请输入数据库密码(和开机密码，sudo密码相同)"',
        'mysql -uaaden -Daaden -p < /home/aaden/aaden-resource-track/aaden-resource-track.sql',
        'cd /etc/systemd/system',
        'sudo wget http://ik0001.ngrok.aaden.io/aaden-resource-track.service',
        'sudo systemctl daemon-reload',
        'sudo systemctl enable aaden-resource-track.service',
        'sudo systemctl start aaden-resource-track.service',
        'sudo service aaden-resource-track start',
    ], program.debug)

}

function returnTerminal() {

}

function editIni() {
    cli.executeInShell([
        'sudo chmod 777 /var/www/html/Resource/config/config.ini',
        'aaden-cli fix-cronjob',
    ], program.debug)

    editConfigIni(composeMany([
        setConfig('Email', 'AutoSend3in1LastMonth', true),
        setConfig('Email', 'DoNotSendZbonWhenPrint', true),
        setConfig('Email', 'AutoSend3in1Today', false),
    ]))()
}

function autoSendSummaryLastMonth() {
    cli.executeInShell([
        'sudo chmod 777 /var/www/html/Resource/config/config.ini',
        'aaden-cli fix-cronjob',
    ], program.debug)

    editConfigIni(setConfig('Email', 'AutoSendSummaryLastMonth', true))()
}

function editConfigIni(f) {
    return () => {
        const ini = require('ini')
        const filePath = '/var/www/html/Resource/config/config.ini'
        const info = ini.parse(fs.readFileSync(filePath, 'utf-8'))
        f(info)
        fs.writeFileSync(filePath, ini.stringify(info))
    }
}

function setConfig(section, key, value) {
    return file => {
        if (!file[section]) {
            file[section] = {}
        }
        file[section][key] = value
        return file
    }
}

function composeMany(fs) {
    return fs.reduce((f, g) => x => g(f(x)), x => x)
}

function getPrivilegeCMD(path, pri = '+x', relativePath = true) {
    const command = []
    if (relativePath) {
        command.push(goIntoRootDir())
    }
    command.push(`echo "Innerken322." | sudo -S chmod ${pri} ${path}`)
    return command
}

function autoWriteGdpdu() {
    const files = ['AadenDeploy/Utils/writeGdpduService.sh']
    runMultiple(files)
}
