const util = require('util')
const colors = require('colors')
const {spawnSync, spawn} = require('child_process')

function getLine(char, lineLength = 20) {
    return char.repeat(lineLength)
}

function commandBuilder(arr) {
    return arr.join(' && ')
}

function showCommand(arr) {
    console.log(getLine('>'))
    console.log(arr.join('\n').cyan)
    console.log('')
}

function executeInShell(cmd, debug = false, needResult = false) {
    let _cmd = commandBuilder(cmd)
    try {
        showCommand(cmd)
        if (debug) {
            return {
                result: false
            }
        }
        if (needResult) {
            const res = spawnSync(_cmd, [], {
                shell: true, stdio: 'pipe', encoding: 'utf-8'
            })
            return {
                result: true, output: res.stdout
            }
        } else {
            spawn(_cmd, [], {
                shell: true, stdio: 'inherit',
            })
            return {
                result: true
            }
        }

    } catch (e) {
        console.log(getLine('*'))
        console.log(e.bgRed)
        console.log(_cmd)
        console.log(getLine('*'))
    }
    console.log(getLine('*'))
    return {result: false}
}

module.exports = {
    getLine, executeInShell
}
