const dayjs = require("dayjs")
const {hillo} = require('hillo')

export async function deviceEcho(frontEndVersion, cliVersion) {
    hillo.initial('http://localhost/PHP/')
    const myDeviceId = await getCurrentDeviceId()
    const taxList = await hillo.get('TaxRate.php?op=getList&lang=DE')
    console.log('echo for device', myDeviceId)
    if (parseInt(myDeviceId) === -1) {
        return
    }
    await hillo.jsonPost('https://deviceecho-evhwqutgjq-ey.a.run.app', {
        deviceId: myDeviceId,
        frontendVersion: frontEndVersion,
        cliVersion,
        backendVersion: await getCurrentBackendVersion(),
        timestamp: dayjs().valueOf(),
        restaurantInfo: {...await getNiceRestaurantInfo(), ...taxList},
        accessFrom: 'aaden-cli v' + cliVersion,
    })
    console.log('report to remote server complete')
}

export async function getCurrentBackendVersion() {
    return (await hillo.get('MyVersion.php?op=version', {}, {
        mode: 'no-cors'
    })).version
}

export async function getCurrentDeviceId() {
    try {
        return (await hillo.get('AccessLog.php?op=deviceId')).content
    } catch (e) {
        console.log(e)
        return -1
    }
}

export async function getNiceRestaurantInfo() {
    return (await hillo.get('Restaurant.php?op=view')).content[0]
}

